-- Original implementation by:
-- brotherhobbes@gmail.com
-- Adapted further by Ammo

assert( oRA, "oRA not found!")

------------------------------
--      Are you local?      --
------------------------------

local L = AceLibrary("AceLocale-2.2"):new("oRALLoot")

local lootmethods = {
	["Need before greed"] = "needbeforegreed",
	["Free for all"] = "freeforall",
	["Round robin"] = "roundrobin",
	["Master looter"] = "master",
	["Group loot"] = "group",
}

local lootthresholds = {
	["Poor"] = 0,
	["Common"] = 1,
	["Uncommon"] = 2,
	["Rare"] = 3,
	["Epic"] = 4,
	["Legendary"] = 5,
	["Artifact"] = 6,
}

----------------------------
--      Localization      --
----------------------------

L:RegisterTranslations("enUS", function() return {
	["lootleader"] = true,
	["loot"] = true,
	["Loot"] = true,
	["Leader/Loot"] = true,
	["Options for loot."] = true,
	["Method"] = true,
	["Threshold"] = true,
	["Set the loot method."] = true,
	["Set the loot threshold."] = true,
	["Free for all"] = true,
	["Round robin"] = true,
	["Master looter"] = true,
	["Group loot"] = true,
    ["Need before greed"] = true,
    ["<method>"] = true,
    ["<threshold>"] = true,
    ["Poor"] = true,
	["Common"] = true,
	["Uncommon"] = true,
	["Rare"] = true,
	["Epic"] = true,
	["Legendary"] = true,
	["Artifact"] = true,
} end )

L:RegisterTranslations("zhTW", function() return {
	["lootleader"] = "物品分配",
	["loot"] = "拾取",
	["Loot"] = "拾取",
	["Leader/Loot"] = "Leader/Loot",
	["Options for loot."] = "拾取設定",
	["Method"] = "拾取方式",
	["Threshold"] = "品質",
	["Set the loot method."] = "設定拾取方式",
	["Set the loot threshold."] = "設定拾取品質",
	["Free for all"] = "自由拾取",
	["Round robin"] = "輪流拾取",
	["Master looter"] = "隊長分配",
	["Group loot"] = "隊伍分配",
  ["Need before greed"] = "需求優先",
    ["<method>"] = "<拾取>",
    ["<threshold>"] = "<品質>",
    ["Poor"] = "劣質",
	["Common"] = "一般",
	["Uncommon"] = "優秀",
	["Rare"] = "精良",
	["Epic"] = "史詩",
	["Legendary"] = "傳說",
	["Artifact"] = "神器",
} end )

L:RegisterTranslations("frFR", function() return {
	--["lootleader"] = true,
	--["loot"] = true,
	["Loot"] = "Butin",
	["Leader/Loot"] = "Chef/Butin",
	["Options for loot."] = "Options concernant le butin.",
	["Method"] = "M\195\169thode",
	["Threshold"] = "Seuil",
	["Set the loot method."] = "D\195\169termine la m\195\169thode de distribution du butin.",
	["Set the loot threshold."] = "D\195\169termine le seuil du butin.",
	["Free for all"] = "Acc\195\168s libre",
	["Round robin"] = "Chacun son tour",
	["Master looter"] = "Ma\195\174tre du butin",
	["Group loot"] = "Butin de groupe",
	["Need before greed"] = "Le besoin avant la cupidit\195\169",
	["<method>"] = "<m\195\169thode>",
	["<threshold>"] = "<seuil>",
	["Poor"] = "Camelote",
	["Common"] = "Commun",
	["Uncommon"] = "Inhabituel",
	--["Rare"] = true,
	["Epic"] = "Epique",
	["Legendary"] = "L\195\169gendaire",
	["Artifact"] = "Art\195\169fact",
} end )

L:RegisterTranslations("deDE", function() return {
	-- ["lootleader"] = "",
	-- ["loot"] = "",
	["Loot"] = "Loot",
	["Leader/Loot"] = "Anf\195\188hrer/Loot",
	["Options for loot."] = "Optionen f\195\188r das Erbeuten von Gegenst\195\164nden.",
	["Method"] = "Methode",
	["Threshold"] = "Schwelle",
	["Set the loot method."] = "Setze die Loot-Methode.",
	["Set the loot threshold."] = "Setze die Pl\195\188nder-Schwelle.",
	["Free for all"] = "Jeder gegen Jeden",
	["Round robin"] = "Reihum",
	["Master looter"] = "Pl\195\188ndermeister",
	["Group loot"] = "Pl\195\188ndern als Gruppe",
	["Need before greed"] = "Bedarf vor Gier",
	["<method>"] = "<Methode>",
	["<threshold>"] = "<Schwelle>",
	["Poor"] = "Schlecht",
	["Common"] = "H\195\164ufig",
	["Uncommon"] = "Selten",
	["Rare"] = "Rar",
	["Epic"] = "Episch",
	["Legendary"] = "Legend\195\164r",
	["Artifact"] = "Artefakt",
} end )

----------------------------------
--      Module Declaration      --
----------------------------------

oRALLoot = oRA:NewModule(L["lootleader"])
oRALLoot.defaults = {
	method = L["Master looter"],
	threshold = L["Uncommon"],
	master = UnitName("player"),
}
oRALLoot.leader = true
oRALLoot.name = L["Leader/Loot"]
oRALLoot.consoleCmd = L["loot"]
oRALLoot.consoleOptions = {
	type = "group",
	name = L["Loot"],
	desc = L["Options for loot."],
	disabled = function() return not oRA:IsActive() end,
	args = {
		[L["Method"]] = {
			type = "text",
			name = L["Method"], desc = L["Set the loot method."],
			get = function() return oRALLoot.db.profile.method end,
			set = function(v) 
					oRALLoot.db.profile.method = v
					oRALLoot:SetLootMethod()
				  end,
			validate = { L["Free for all"], L["Round robin"], L["Master looter"], L["Group loot"], L["Need before greed"] },
			usage = L["<method>"], 
		},
		[L["Threshold"]] = {
			type = "text",
			name = L["Threshold"], desc = L["Set the loot threshold."],
			get = function() return oRALLoot.db.profile.threshold end,
			set = function(v)
					oRALLoot.db.profile.threshold = v
					oRALLoot:SetLootMethod()
					end,
			validate = { L["Poor"], L["Common"], L["Uncommon"], L["Rare"], L["Epic"], L["Legendary"], L["Artifact"]},
			usage = L["<threshold>"], 
		},
	}
}


------------------------------
--      Initialization      --
------------------------------

function oRALLoot:OnEnable()
	self:SetLootMethod()
end

----------------------
-- Command handlers --
----------------------

function oRALLoot:SetLootMethod()
	if not IsRaidLeader() then return end

	local method = self.db.profile.method
	local threshold = self.db.profile.threshold

	if method and L:HasReverseTranslation( method ) and lootmethods[L:GetReverseTranslation(method)] then
		method = lootmethods[L:GetReverseTranslation(method)]
	else
		method = self.defaults.method
		method = lootmethods[L:GetReverseTranslation(method)]
	end
	
	if threshold and L:HasReverseTranslation( threshold ) and lootthresholds[L:GetReverseTranslation(threshold)] then
		threshold = lootthresholds[L:GetReverseTranslation(threshold)]
	else
		threshold = self.defaults.threshold
		threshold = lootthresholds[L:GetReverseTranslation(threshold)]
	end	
	
	-- SetLootMethod("method"{,"masterPlayer" or ,threshold})
	-- method  "group", "freeforall", "master", "neeedbeforegreed", "roundrobin".
	-- threshold  0 poor  1 common  2 uncommon  3 rare  4 epic  5 legendary  6 artifact    
	
	SetLootMethod(method, self.db.profile.master, threshold)
	if method == "master" or method == "group" then
		self:ScheduleEvent("oralootthreshold", function(threshold) SetLootThreshold(threshold) end, 3, threshold)
	end
end
